Core - Task # 29278

Epic # 55070 (Accepted): Workpackages

Epic # 54851 (Accepted): WP: Workspaces IRRE & MM bugfixes
Story # 54853 (Accepted): As a user | want to correctly create, modify, preview and publish IRRE & MM related workspace changes
Task # 56376 (Resolved): Invalid relations of IRRE records in workspaces

Status: Rejected Priority: Must have
Author: Tizian Schmidlin Category: IRRE
Created: 2011-08-26 Assigned To:

Updated: 2014-03-24 Due date:

TYPO3 Version: 4.5

PHP Version: 5.2

Complexity: hard

Sprint Focus:

Subject: Lost relations on copying IRRE children in workspaces

Description

Hi there,

| figured out somekind of real big and ugly bug.
When using IRRE in an extension like powermail, the child fields won't get created in the workspace mode.
| thinks that since Workspace is part of the core now, this kind of has got its place here.
Here how to reproduce:
Install powermail (don't event need to configure highly)
1. Create a content element of type powermail
2. Create a fieldset
3. Create a field in this fieldset
4. Set a recipient (since it's somekind of needed in some versions)
Now go to workspace mode. Copy the element and paste it. You can be a adminstrator or normal TYPO3 user, this doesn't matter.
When you open the newly copied element, you'll see, that the element has no fieldset nor fields and they aren't in the database
though.
What | firgured out:
- The content get's processed properly
- The fields of the child elements get processed, event the child elements of the content child element
- for some reason, there is nothing written to the child tables.
| tested this with the latest trunk version of class.t3lib_tcemain.php of TYPO3 4.5.3
I'll continue watching out for a solution, but since | didn't find yet the point where it get's problematic, I'm not very confident...

Thanks for your support.

Greets Tizian

Related issues:
related to Core - Task # 45132: Faulty translation behavior of IRRE using wor... Rejected 2013-02-04

related to Core - Task # 45214: Problems on publishing complex IRRE structure On Hold 2013-02-06
related to Grid Elements - Bug # 46747: Translating Childelements in Grid-Con... Rejected 2013-03-28
related to Grid Elements - Bug # 46749: Drag'n'drop child elements inside Giri... Rejected 2013-03-28
related to Core - Task # 45676: Workspace references are not considered Rejected 2013-02-20
duplicated by Core - Bug # 39317: Copying records with IRRE: subrecords only ... Closed 2012-07-27
History

#1 - 2011-08-27 19:43 - Ingmar Schlecht

- Assigned To set to Oliver Hader

@Olly, do you think this is an IRRE core bug with workspaces, or is it due to wrong TCA configuration from powermail?
~ friendly ghost

#2 - 2013-01-17 22:58 - Oliver Hader

- Status changed from New to Accepted

- Target version set to 4.5.23

#3 - 2013-01-18 11:07 - Oliver Hader

In general there are some issues that need to be tackled (all on workspaces)

localization of IRRE parent records and related children

Localization works like copying internally and thus at the end gets back to the copy logic.

discarding elements on workspaces

That's the most funny thing that, since discarding/deleting element is basically the same as creating a copy, but with accordant data to set deleted flags
(the delete placeholder).
All actions that are related to that need to use versionizeRecord() for dependent children.

copying IRRE parent records and related children

The copy logic tries to determine whether a "copy action" is a localization or a real copy of an accordant parent.

If on workspaces, currently versionizeRecord() is used which just creates a new version, but without using a placeholder - thus, there is no indication
that it's a plain new record and not related to to any existing record. This means, that versionizeRecord() only shall be used if this was the initial
command (the indication is done by using the $workspaceOptions) array.

resolving concrete version record instead of placeholder record

In case the parent record was copied on a workspace, then this results in a new-placeholder which is overlaid by the concrete version in the
workspace.
In any kind all children need to point to the concrete version instead of the placeholder record.

#4 - 2013-01-18 11:09 - Oliver Hader
- Subject changed from Copying contents using IRRE in Workspace loses child elements to Lost relations on copying IRRE children in workspaces

#5 - 2013-01-18 11:22 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch TYPO3_4-7 has been pushed to the review server.
It is available at https://review.typo3.org/17587
https://review.typo3.org/17587

#6 - 2013-01-30 16:10 - Gerrit Code Review

Patch set 2 for branch TYPO3_4-7 has been pushed to the review server.

It is available at https://review.typo3.org/17587

#7 - 2013-01-31 19:07 - Gerrit Code Review

Patch set 3 for branch TYPO3_4-7 has been pushed to the review server.

It is available at https://review.typo3.org/17587

#8 - 2013-01-31 19:13 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/17902

#9 - 2013-02-04 13:45 - Gerrit Code Review

Patch set 4 for branch TYPO3_4-7 has been pushed to the review server.

It is available at https://review.typo3.org/17587

#10 - 2013-02-05 12:01 - Gerrit Code Review

Patch set 5 for branch TYPO3_4-7 has been pushed to the review server.

It is available at https://review.typo3.org/17587

#11 - 2013-02-06 11:43 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-5 has been pushed to the review server.

It is available at https://review.typo3.org/18046

#12 - 2013-02-13 13:25 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/17902

#13 - 2013-02-13 14:23 - Gerrit Code Review

Patch set 6 for branch TYPO3_4-7 has been pushed to the review server.

It is available at https://review.typo3.org/17587

#14 - 2013-03-04 10:11 - Gerrit Code Review

Patch set 2 for branch TYPO3_4-5 has been pushed to the review server.

It is available at https://review.typo3.org/18046
#15 - 2013-06-11 16:24 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/17902

#16 - 2013-07-05 11:47 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/17902

#17 - 2014-01-08 22:37 - Oliver Hader
- Parent task set to #54853

- Is Regression set to No

#18 - 2014-01-08 22:38 - Oliver Hader
- Assigned To deleted (Oliver Hader)

#19 - 2014-01-08 22:39 - Oliver Hader

- Status changed from Under Review to Needs Feedback

#20 - 2014-02-18 00:45 - Oliver Hader
- Status changed from Needs Feedback to On Hold

#21 - 2014-02-27 13:19 - Oliver Hader
- Parent task changed from #54853 to #56376

#22 - 2014-03-24 09:46 - Oliver Hader

- Status changed from On Hold to Rejected

Solved with issue #56376
